# coding: utf-8

"""
    Gradient AI API

    Interface for interacting with Gradient AI.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@gradient.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, conint, validator

class MeaningBasedChunker(BaseModel):
    """
    MeaningBasedChunker
    """
    chunker_type: StrictStr = Field(..., alias="chunkerType")
    overlap: Optional[conint(strict=True, ge=0)] = None
    sentence_group_length: Optional[conint(strict=True, gt=0)] = Field(None, alias="sentenceGroupLength")
    similiarity_percent_threshold: Optional[conint(strict=True, le=100, ge=0)] = Field(None, alias="similiarityPercentThreshold")
    size: Optional[conint(strict=True, gt=0)] = None
    additional_properties: Dict[str, Any] = {}
    __properties = ["chunkerType", "overlap", "sentenceGroupLength", "similiarityPercentThreshold", "size"]

    @validator('chunker_type')
    def chunker_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('meaningBasedChunker'):
            raise ValueError("must be one of enum values ('meaningBasedChunker')")
        return value

    class Config:
        """pydantic.v1 configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MeaningBasedChunker:
        """Create an instance of MeaningBasedChunker from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if overlap (nullable) is None
        # and __fields_set__ contains the field
        if self.overlap is None and "overlap" in self.__fields_set__:
            _dict['overlap'] = None

        # set to None if sentence_group_length (nullable) is None
        # and __fields_set__ contains the field
        if self.sentence_group_length is None and "sentence_group_length" in self.__fields_set__:
            _dict['sentenceGroupLength'] = None

        # set to None if similiarity_percent_threshold (nullable) is None
        # and __fields_set__ contains the field
        if self.similiarity_percent_threshold is None and "similiarity_percent_threshold" in self.__fields_set__:
            _dict['similiarityPercentThreshold'] = None

        # set to None if size (nullable) is None
        # and __fields_set__ contains the field
        if self.size is None and "size" in self.__fields_set__:
            _dict['size'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MeaningBasedChunker:
        """Create an instance of MeaningBasedChunker from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MeaningBasedChunker.parse_obj(obj)

        _obj = MeaningBasedChunker.parse_obj({
            "chunker_type": obj.get("chunkerType"),
            "overlap": obj.get("overlap"),
            "sentence_group_length": obj.get("sentenceGroupLength"),
            "similiarity_percent_threshold": obj.get("similiarityPercentThreshold"),
            "size": obj.get("size")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

